-- museum.lua: On-Foot Audio Player [nclok1405]
-- SR2 district script
-- 3/28/07

-- Change this to false to not randomize the play order
OFAP_SHUFFLE = true

-- Change this to true if you want to leave the in-game car radio untouched
OFAP_CAR_RADIO = false

OFAP_RADIO = {
	{
		name = "OFF",
		music = {}
	},
	{
		name = "MIXTAPE",
		music = {
			-- Place your favorite music here...
			"MUS_SAINTS_CLUB_1",
		}
	},
	{
		name = "89.0 GENERATION X",
		music = {
			"890gen_A_Deftones",					-- Deftones - Hole In The Earth
			"890GEN_A_Galactic",					-- Galactic F. Lyrics Born - I Got It
			"890gen_A_HotHotHeat",					-- Hot Hot Heat - Let Me In
			"890GEN_A_Jet",							-- Jet - Put Your Money Where Your Mouth Is
			"890gen_B_MyChemicalRomance",			-- My Chemical Romance - Teenagers
			"890gen_B_PanicAtTheDisco",				-- Panic! At The Disco - Lying Is The Most Fun
			"890gen_B_Paramore",					-- Paramore - Misery Business
			"890gen_B_PlainWhiteTs",				-- Plain White T's - Hate
			"890gen_B_RedJumpsuitApparatus",		-- Red Jumpsuit Apparatus - Face Down
			"890gen_C_TakingBackSunday",			-- Taking Back Sunday - MakeDamnSure
			"890gen_C_TheLifeAndTimes",				-- The LIfe And Times - Coat Of Arms
			"890gen_C_TheSubways",					-- The Subways - Rock And Roll Queen
			"890gen_C_TheUsed",						-- The Used - All That I've Got
			"890gen_C_MinusTheBear",				-- Minus The Bear - Knights
		}
	},
	{
		name = "95.4 KRHYME FM",
		music = {
			"954krh_A_Amerie",						-- Amerie - One Thing
			"954krh_A_Apache",						-- Apache - Gangsta Bitch
			"954krh_A_BeanieSigel",					-- Beanie Sigel - What A Thug About
			"954krh_A_BigPunisher",					-- Big Punisher F. Fat Joe - Twinz
			"954krh_B_Cassie",						-- Cassie - Me And U
			"954krh_B_ChrisetteMichelle",			-- Chrisette Michelle - Good Girl
			"954krh_B_DJQuik",						-- DJ Quik F. B Real - Fandango
			"954krh_B_JossStone",					-- Joss Stone - Tell Me Bout It
			"954krh_B_Kelis",						-- Kelis - Trick Me
			"954krh_C_LloydBanks",					-- Lloyd Banks - Hands Up
			"954krh_C_Nas",							-- Nas - New York State Of Mind
			"954krh_C_NeYo",						-- Ne Yo - So Sick
			"954krh_C_RunDMC",						-- Run DMC - Sucker MCs
			"954krh_C_Wale",						-- Wale - Ridin In That Black Joint
			"954krh_C_YoungJeezy",					-- Young Jeezy - I Luv It
		}
	},
	{
		name = "97.6 K12 FM",
		music = {
			"976k12_A_CrystalCastles",				-- Amerie - One Thing
			"976k12_A_DanielMansury",				-- Apache - Gangsta Bitch
			"976k12_A_DeathFromAbove",				-- Beanie Sigel - What A Thug About
			"976k12_A_DoesItOffendYouYeah",			-- Big Punisher F. Fat Joe - Twinz
			"976k12_B_GunsAndBombs",				-- Guns N Bombs - Crossover Appeal
			"976k12_B_HotChip",						-- Hot Chip - Over And Over
			"976k12_B_JuanMacLean",					-- The Juan MacLean - Give Me Every Little Thing
			"976k12_B_LCDSoundsystem",				-- LCD Soundsystem - North American Scum
			"976k12_C_MatthewDear",					-- Matthew Dear - Don And Sherri
			"976k12_C_MSTRKRFT",					-- MSTRKRFT - Street Justice
			"976k12_C_TRS80",						-- TRS80 - Special Effect
		}
	},
	{
		name = "FUNK 98.4",
		music = {
			"984funk_A_Amnesty",					-- Amnesty - Love Fades
			"984funk_A_BadMedicine",				-- Bad Medicine - Trespasser
			"984funk_A_ChocolateStar",				-- Chocolate Star - Gotta Get Your Love
			"984funk_A_CliffNyren",					-- Cliff Nyren - Keep Running
			"984funk_B_EbonyRhythmBand",			-- Ebony Rhythm Band - Drugs Ain't Cool
			"984funk_B_LeonMitchison",				-- Leon Mitchison - Street Scene
			"984funk_B_LutherDavisGroup",			-- Luther Davis Group - You Can Be A Star
			"984funk_B_PureEssence",				-- Pure Essence - Wake Up Pt. 1 and 2
			"984funk_B_SheilaSkipworth",			-- Sheila Skipworth - Look What You've Done To Me
			"984funk_C_DaytonSidewinders",			-- Dayton Sidewinders - Funky In Here
			"984funk_C_RhythmMachine",				-- The Rhythm Machine - Put A Smile On Time
			"984funk_C_SoulSeven",					-- The Soul Seven - The Cissy's Thang
			"984funk_C_UPCAllStars",				-- UPC Allstars - Don't Get Discouraged
		}
	},
	{
		name = "99.0 THE UNDERGROUND",
		music = {
			"990UND_A_Architects",
			"990UND_A_BoundStems",
			"990UND_A_DeerHunter",
			"990UND_A_Kasabian",
			"990UND_B_MarnieStern",
			"990UND_B_OkkervilRiver",
			"990UND_B_Shiner",
			"990UND_B_Shipwreck",
			"990UND_B_SouthStreet",
			"990UND_C_TheRakes",
			"990UND_C_TheSaps",
			"990UND_C_TheThermals",
			"990UND_C_TheTwilightSad",
			"990UND_C_TokyoPoliceClub",
		}
	},
	{
		name = "102.4 KLASSIC FM",
		music = {
			"KLSC_ARRIVAL_OF_THE_QUEEN_OF_SHEBA",			-- G. F. Handel - Arrival of the Queen of Sheba
			"KLSC_BRANDENBURG_CONCERTO_NO_3_ALLEGRO",		-- J. S. Bach - Brandenburg Concerto No. 3 - Allegro
			"KLSC_CONCERTO_NO_4_IN_A",						-- J. S. Bach - Concerto No. 4 In A
			"KLSC_COPPELIA_BALLET_SUITE",					-- Delibes - Coppelia Ballet Suite
			"KLSC_EINE_KLEINE_NACHTMUSIK_1ST_MOVT",			-- W. A. Mozart - Eine Kleine Nachtmusik
			"KLSC_FOUR_SEASONS_THE_SPRING_THE_ALLEGRO",		-- Vivaldi - The Four Seasons No. 1 - The Spring
			"KLSC_FOUR_SEASONS_THE_SUMMER_THE_PRESTO",		-- Vivaldi - The Four Seasons No. 2 - The Summer
			"KLSC_HAFFNER_SERENADE_NO_7_ALLEGRO_MAESTOSO",	-- W. A. Mozart - Haffner Serenade No. 7 In D Major
			"KLSC_HUNGARIAN_DANCE_NO__5",					-- J. Brahms - Hungarian Dance No. 5
			"KLSC_MOONLIGHT_SONATA__FIRST_MOVEMENT",		-- Beethoven - Moonlight Sonata
			"KLSC_MUSIC_FOR_THE_ROYAL_FIREWORKS_OUVERTURE",	-- G. F. Handel - Music For The Royal Fireworks (Overture)
			"KLSC_NUTCRACKER_TREPAK",						-- Tchaikovsky - Nutcracker Trepak
			"KLSC_OVERTURE_MARRIAGE_OF_FIGARO",				-- W. A. Mozart - Marriage of Figaro (Overture)
			"KLSC_PEER_GYNT__SUITE_NO_1_OP_46",				-- Grieg - In The Hall Of The Mountain King
			"KLSC_PEER_GYNT_SUITE_NO_1_ANITRA_S_DANCE",		-- Grieg - Anitra's Dance
			"KLSC_RIDE_OF_THE_VALKYRIES",					-- Wagner - Ride of the Valkyries
			"KLSC_SLEEPING_BEAUTY_WALTZ",					-- Tchaikovsky - Sleeping Beauty Waltz
			"KLSC_STRING_QUARTET_IN_G_MAJOR_2ND_MVT",		-- W. A. Mozart - String Quartet In G Major
			"KLSC_SYM_NO_5_IN_C_MINOR_ALLEGRO_CON_BRIO",	-- Beethoven - Symphony No. 5 In C Minor - Allegro Con Brio
			"KLSC_SYMPHONY_NO_40___1ST_MOVT",				-- W. A. Mozart - Symphony No. 40 - 1st Movement
			"KLSC_SYMPHONY_NO_5_IN_C_MINOR_ALLEGRO",		-- Beethoven - Symphony No. 5 in C Minor - Allegro
			"KLSC_TOCCATA_AND_FUGUE_IN_D_MINOR",			-- J. S. Bach - Toccata and Fugue In D Minor
			"KLSC_WATER_MUSIC_SUITE_NO_1_OVERTURE",			-- G. F. Handel - Water Music Suite No. 1 - Overture
			"KLSC_WATER_MUSIC_SUITE_NO_1_PRESTO",			-- G. F. Handel - Water Music Suite No. 1 - Presto
		}
	},
	{
		name = "103.6 420 FM",
		music = {
			"1036fou_A_BarringtonLevy",
			"1036fou_A_Beanieman",
			"1036fou_A_BornJamericans",
			"1036fou_A_BujuBanton",
			"1036fou_B_ChakaDemus",
			"1036fou_B_DennisBrown",
			"1036fou_B_EekAMouse",
			"1036fou_B_ElephantMan",
			"1036fou_C_MrVegas",
			"1036fou_C_NinjaMan",
			"1036fou_C_VybzCartel",
		}
	},
	{
		name = "105.0 EZZZY FM",
		music = {
			"EZZZY_BACHELOR_SAMBA",
			"EZZZY_BERG_UND_TAL",
			"EZZZY_BOSSA_CUBANA",
			"EZZZY_CHANSON_POUR_TOI",
			"EZZZY_CIELITO_LINDO",
			"EZZZY_COCONUTS",
			"EZZZY_COLONIE_CELESTE",
			"EZZZY_DANCING_ON_THE_AVENUE",
			"EZZZY_DOLCE_VITA",
			"EZZZY_FACE_TO_FACE",
			"EZZZY_GIRL_LIKE_YOU",
			"EZZZY_JARABE_TAPATIO",
			"EZZZY_JUST_STROLLING_ALONG",
			"EZZZY_KALAMAZOO_STYLE",
			"EZZZY_LOVE_FOR_LIFE",
			"EZZZY_MARVELLOUS_SINGERS_REMIX",
			"EZZZY_NAUGHTY_BUT_NICE",
			"EZZZY_STEREO_CHA_CHA",
			"EZZZY_SUNNY_DAY_IN_HEIDELBERG",
			"EZZZY_SWING_PANAME",
			"EZZZY_TCHOUPA_TWIST",
			"EZZZY_TOOBA_BOOGIE",
			"EZZZY_WALKIE_TALKIE",
			"EZZZY_WHISTLE_HAPPY",
		}
	},
	{
		name = "105.0 THE WORLD",
		music = {
			"1050WOR_A_Baidoushka",
			"1050WOR_A_Bangara",
			"1050WOR_A_BrasilianFiesta",
			"1050WOR_A_Cigany",
			"1050WOR_A_Connaught",
			"1050WOR_A_DrumJig",
			"1050WOR_A_ElViento",
			"1050WOR_B_EmeraldJig",
			"1050WOR_B_FrissARosa",
			"1050WOR_B_GoodMorningPolka",
			"1050WOR_B_GypsyDance",
			"1050WOR_B_HotNights",
			"1050WOR_B_Humors",
			"1050WOR_B_HungarianSundance",
			"1050WOR_C_MamboDeFito",
			"1050WOR_C_Mandilatos",
			"1050WOR_C_MountainHut",
			"1050WOR_C_OverTheMoor",
			"1050WOR_C_Schenkt",
			"1050WOR_C_TheDrunkardsSong",
			"1050WOR_C_Zahrat",
		}
	},
	{
		name = "THE KRUNCH 106.66",
		music = {
			"1066kru_A_DeadlySinners",
			"1066kru_A_NothingLeft",
			"1066kru_A_BatCountry",
			"1066kru_A_Resurrection",
			"1066kru_B_MilkLizard",
			"1066kru_B_Unsung",
			"1066kru_B_Stars",
			"1066kru_B_Redneck",
			"1066kru_B_ColonyOfBirchmen",
			"1066kru_C_GhostsOfPerdition",
			"1066kru_C_BarnBurner",
			"1066kru_C_HorribleNight",
			"1066kru_C_Anthem",
			"1066kru_C_Woman",
		}
	},
	{
		name = "107.77 THE MIX FM",
		music = {
			"10777MIX_A_TAKEONME",					-- A-Ha - Take On Me
			"10777MIX_A_KarmaChameleon",			-- Culture Club - Karma Chameleon
			"10777MIX_A_TheReflex",					-- Duran Duran - The Reflex
			"10777MIX_A_FinalCountdown",			-- Europe - The Final Countdown
			"10777MIX_B_OutOfTouch",				-- Hall and Oates - Out of Touch
			"10777MIX_B_WorkingForTheWeekend",		-- Loverboy - Working For The Weekend
			"10777MIX_B_DownUnder",					-- Men At Work - Land Down Under
			"10777MIX_B_SisterChristian",			-- Night Ranger - Sister Christian
			"10777MIX_C_ForgetAboutMe",				-- Simple Minds - Don't You Forget About Me
			"10777MIX_C_RuleTheWorld",				-- Tears For Fears - Everybody Wants To Rule The World
			"10777MIX_C_PrettyInPink",				-- The Psychedelic Furs - Pretty In Pink
		}
	},
	{
		name = "ZOMBIE UPRISING",
		music = {
			"Zombie",								-- Zombie Uprising
		}
	},
}

OFAP_PC_BTN_RADIO_PREV = 29
OFAP_PC_BTN_RADIO_NEXT = 30
OFAP_PC_BTN_HORN = 26

Ofap_station = 1
Ofap_positions = {}
Ofap_audio_handle = 0

function museum_is_music_already_added(music_name, list)
	for i, m in pairs(list) do
		if m == music_name then
			return true
		end
	end
	return false
end

function museum_init()
end

function museum_main()
	-- Shuffle
	if OFAP_SHUFFLE then
		for z, station in pairs(OFAP_RADIO) do
			local station_name = station.name
			local music_list = station.music
			
			if sizeof_table(music_list) >= 2 then
				debug_print("Shuffling a station: "..station_name.."\n")
				
				-- Create a shuffled list
				local temp_list = {}
				while sizeof_table(temp_list) < sizeof_table(music_list) do
					local n = rand_int(1, sizeof_table(music_list))
					local m = music_list[n]
					
					if not museum_is_music_already_added(m, temp_list) then
						debug_print("Adding music '"..m.."' to the station '"..station_name.."'\n")
						temp_list[sizeof_table(temp_list) + 1] = m
					else
						--debug_print(""..m.." is already in the list\n")
					end
				end
				
				-- Overwrite the original list with the shuffled list
				for i = 1, sizeof_table(music_list) do
					--debug_print("Overwriting "..music_list[i].." with "..temp_list[i].."\n")
					music_list[i] = temp_list[i]
				end
			else
				debug_print("Not shuffling a station: "..station_name.."\n")
			end
		end
	end
	
	-- This function is started while the game is still being loaded.
	-- Wait until the player(s) are ready to respond.
	while (not character_is_ready(LOCAL_PLAYER)) do
		thread_yield()
	end
	if coop_is_active() then
		while (not character_is_ready(REMOTE_PLAYER)) do
			thread_yield()
		end
	end

	while true do
		-- If a cutscene is active, wait until it's over
		while not cutscene_play_check_done() do
			thread_yield()
		end

		-- Check current vehicle
		local carradio = false	-- true if we're using car radio (disables on-foot audio)
		local myride = get_char_vehicle_name(LOCAL_PLAYER)
		if myride ~= "" then
			if not OFAP_CAR_RADIO then
				-- Turn off the car radio
				if radio_get_station(myride) ~= 15 then
					radio_set_station(myride, 15)
				end
				vehicle_set_radio_controls_locked(myride, true)
			else
				carradio = true
			end
		end
		
		if not carradio then
			-- Detect the Station Change buttons
			local station_change = 0
			if player_button_just_pressed(OFAP_PC_BTN_RADIO_PREV) then
				station_change = -1
			elseif player_button_just_pressed(OFAP_PC_BTN_RADIO_NEXT) then
				station_change = 1
			end
			
			-- Switch the station
			if station_change ~= 0 then
				Ofap_station = Ofap_station + station_change
				if Ofap_station < 1 then
					Ofap_station = sizeof_table(OFAP_RADIO)
				end
				if Ofap_station > sizeof_table(OFAP_RADIO) then
					Ofap_station = 1
				end

				if Ofap_station == 1 then
					audio_play("SFX_RADIO_ONOFF_C")
				else
					audio_play("SFX_RADIO_DIAL_C")
				end

				mission_help_clear(SYNC_LOCAL)
				mission_help_table_nag("{PREV_RADIO_IMG} "..OFAP_RADIO[Ofap_station].name.." {NEXT_RADIO_IMG}", "", "", SYNC_LOCAL)
				
				audio_stop(Ofap_audio_handle)
				Ofap_audio_handle = 0
			end
		else
			-- Player entered a car so turn off our audio
			if Ofap_station > 1 then
				audio_play("SFX_RADIO_ONOFF_C")
				Ofap_station = 1
				audio_stop(Ofap_audio_handle)
				Ofap_audio_handle = 0
			end
		end
		
		local current_station = OFAP_RADIO[Ofap_station]
		
		-- If no music is playing now, start a new one
		if (Ofap_audio_handle <= 0) or (not audio_is_playing(Ofap_audio_handle)) then
			if sizeof_table(current_station.music) > 0 then
				if (Ofap_positions[Ofap_station] == nil) or (Ofap_positions[Ofap_station] > sizeof_table(current_station.music)) then
					Ofap_positions[Ofap_station] = 1
				end
				
				Ofap_audio_handle = audio_play(current_station.music[Ofap_positions[Ofap_station]], "music")
				--mission_help_table_nag("Now Playing:"..current_station.music[Ofap_positions[Ofap_station]], "", "", SYNC_LOCAL)
				
				Ofap_positions[Ofap_station] = Ofap_positions[Ofap_station] + 1
			end
		end
		
		if (not character_is_in_vehicle(LOCAL_PLAYER)) and player_button_just_pressed(OFAP_PC_BTN_HORN) then
			-- Skip to the next music
			if sizeof_table(current_station.music) > 0 then
				audio_play("SFX_RADIO_DIAL_C")
				audio_stop(Ofap_audio_handle)
				Ofap_audio_handle = 0
			end
		end
		
		thread_yield()
	end
end
